
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class LocationsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const locations = await db.locations.create(
            {
                id: data.id || undefined,
        
        location_name: data.location_name
        ||
        null
            ,
            
        location_code: data.location_code
        ||
        null
            ,
            
        active: data.active
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await locations.setWarehouse( data.warehouse || null, {
            transaction,
        });
        
        await locations.setParent_location( data.parent_location || null, {
            transaction,
        });
        

        

        

        return locations;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const locationsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                location_name: item.location_name
            ||
            null
            ,
            
                location_code: item.location_code
            ||
            null
            ,
            
                active: item.active
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const locations = await db.locations.bulkCreate(locationsData, { transaction });

        // For each item created, replace relation files
        

        return locations;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const locations = await db.locations.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.location_name !== undefined) updatePayload.location_name = data.location_name;
        
        
        if (data.location_code !== undefined) updatePayload.location_code = data.location_code;
        
        
        if (data.active !== undefined) updatePayload.active = data.active;
        
        
        updatePayload.updatedById = currentUser.id;

        await locations.update(updatePayload, {transaction});

        
        
        if (data.warehouse !== undefined) {
            await locations.setWarehouse(
              
              data.warehouse,
              
              { transaction }
            );
        }
        
        if (data.parent_location !== undefined) {
            await locations.setParent_location(
              
              data.parent_location,
              
              { transaction }
            );
        }
        

        
        

        

        return locations;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const locations = await db.locations.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of locations) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of locations) {
                await record.destroy({transaction});
            }
        });


        return locations;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const locations = await db.locations.findByPk(id, options);

        await locations.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await locations.destroy({
            transaction
        });

        return locations;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const locations = await db.locations.findOne(
            { where },
            { transaction },
        );

        if (!locations) {
            return locations;
        }

        const output = locations.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.inventory_balances_location = await locations.getInventory_balances_location({
            transaction
        });
        
        
        output.inventory_movements_from_location = await locations.getInventory_movements_from_location({
            transaction
        });
        
        output.inventory_movements_to_location = await locations.getInventory_movements_to_location({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.warehouse = await locations.getWarehouse({
            transaction
        });
        
        
        output.parent_location = await locations.getParent_location({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.warehouses,
        as: 'warehouse',
        
        where: filter.warehouse ? {
          [Op.or]: [
            { id: { [Op.in]: filter.warehouse.split('|').map(term => Utils.uuid(term)) } },
            {
              warehouse_name: {
                [Op.or]: filter.warehouse.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.locations,
        as: 'parent_location',
        
        where: filter.parent_location ? {
          [Op.or]: [
            { id: { [Op.in]: filter.parent_location.split('|').map(term => Utils.uuid(term)) } },
            {
              location_name: {
                [Op.or]: filter.parent_location.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.location_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'locations',
                        'location_name',
                        filter.location_name,
                    ),
                };
            }
            
            if (filter.location_code) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'locations',
                        'location_code',
                        filter.location_code,
                    ),
                };
            }
            

            
            

            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.active) {
                where = {
                    ...where,
                active: filter.active,
            };
            }
            


      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.locations.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'locations',
                        'location_name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.locations.findAll({
            attributes: [ 'id', 'location_name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['location_name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.location_name,
        }));
    }

    
};

